unit GifSaving;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Menus, RXSpin;

type
  TForm4 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button1: TButton;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    ColorDialog1: TColorDialog;
    GroupBox2: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Panel1: TPanel;
    Button2: TButton;
    Button3: TButton;
    GroupBox3: TGroupBox;
    CheckBox2: TCheckBox;
    Label1: TLabel;
    RxSpinEdit1: TRxSpinEdit;
    procedure Button1Click(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
    procedure SetOptionsTransparent(Value: Boolean);
    procedure FormShow(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure UpDateOptionsForm;
    procedure CheckBox1Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure RxSpinEdit1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  TOptions = record
               Gif: record
                      Transparent: Boolean;
                      Bgcolor: TColor;
                      Loop: Boolean;
                      FrameRate: LongInt;
                      UseBgColor: Boolean;
                    end;
               Bmp: record
                      PixelFormat: TPixelFormat;
                    end;
             end;

const
  OptionsFile='settings.dat';

var
  DDir: STRING;
  Form4: TForm4;
  CurrentOptions,DefaultOptions,TempOptions: TOptions;

implementation

{$R *.DFM}

procedure TForm4.Button1Click(Sender: TObject);
begin
  CurrentOptions:=TempOptions;
  Close;
end;

procedure TForm4.Panel1Click(Sender: TObject);
begin
  if not ColorDialog1.Execute then Exit;
  Panel1.Color:=ColorDialog1.Color;
  TempOptions.Gif.BgColor:=ColorDialog1.Color;
  RadioButton2.Checked:=True;
end;

procedure TForm4.SetOptionsTransparent(Value: Boolean);
begin
  TempOptions.gif.transparent:=CheckBox1.Checked;
end;

procedure TForm4.FormShow(Sender: TObject);
begin
  TempOptions:=CurrentOptions;
  PageControl1.ActivePage:=TabSheet1;
  UpDateOptionsForm;
end;

procedure TForm4.Button2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm4.Button3Click(Sender: TObject);
begin
  TempOptions:=DefaultOptions;
  UpDateOptionsForm;
end;

procedure TForm4.UpDateOptionsForm;
begin
  {***   Gif}
  CheckBox1.Checked:=TempOptions.Gif.Transparent;
  case TempOptions.Gif.Transparent of
  True:begin
         RadioButton1.Enabled:=False;
         RadioButton2.Enabled:=False;
         Panel1.Enabled:=False;
       end;
 False:begin
         RadioButton1.Enabled:=True;
         RadioButton2.Enabled:=True;
         Panel1.Enabled:=True;
       end;
  end;
  RadioButton1.Checked:=not TempOptions.Gif.UseBgColor;
  RadioButton2.Checked:=TempOptions.Gif.UseBgColor;
  Panel1.Color:=TempOptions.Gif.BgColor;
  {***   Gif}
  CheckBox2.Checked:=TempOptions.Gif.Loop;
  RxSpinEdit1.Value:=TempOptions.Gif.FrameRate;
  {***  Bmp}
  case TempOptions.Bmp.PixelFormat of
    pf4bit: RadioGroup1.ItemIndex:=0;
    pf8bit: RadioGroup1.ItemIndex:=1;
    pf16bit: RadioGroup1.ItemIndex:=2;
    pf24bit: RadioGroup1.ItemIndex:=3;
    pf32bit: RadioGroup1.ItemIndex:=4;
  end;
end;

procedure TForm4.CheckBox1Click(Sender: TObject);
begin
  TempOptions.Gif.Transparent:=CheckBox1.Checked;
  UpDateOptionsForm;
end;

procedure TForm4.RadioButton1Click(Sender: TObject);
begin
  TempOptions.Gif.UseBgColor:=False;
end;

procedure TForm4.RadioButton2Click(Sender: TObject);
begin
  TempOptions.Gif.UseBgColor:=True;
end;

procedure TForm4.CheckBox2Click(Sender: TObject);
begin
  TempOptions.Gif.Loop:=CheckBox2.Checked;
end;

procedure TForm4.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.ItemIndex of
  0: TempOptions.Bmp.PixelFormat:=pf4bit;
  1: TempOptions.Bmp.PixelFormat:=pf8bit;
  2: TempOptions.Bmp.PixelFormat:=pf16bit;
  3: TempOptions.Bmp.PixelFormat:=pf24bit;
  4: TempOptions.Bmp.PixelFormat:=pf32bit;
  end;
end;

procedure TForm4.FormHide(Sender: TObject);
var
  F: TFileStream;
begin
  F:=TFileStream.Create(DDir+'\'+OptionsFile,fmCreate);
  F.Write(CurrentOptions,SizeOf(CurrentOptions));
  F.Free;
end;

procedure TForm4.RxSpinEdit1Change(Sender: TObject);
begin
  TempOptions.Gif.FrameRate:=Round(RxSpinEdit1.Value);
end;

end.
