unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, FormatBIFF,
  RxGif, About, ComCtrls, FileCtrl;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Panel1: TPanel;
    PageControl2: TPageControl;
    BIFF: TTabSheet;
    ListBox1: TListBox;
    PageControl1: TPageControl;
    TabNone: TTabSheet;
    GroupBox4: TGroupBox;
    TabBAM: TTabSheet;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    ScrollBar1: TScrollBar;
    StaticText2: TStaticText;
    UpDown1: TUpDown;
    StaticText7: TStaticText;
    StaticText3: TStaticText;
    Button1: TButton;
    GroupBox3: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    StaticText1: TStaticText;
    StaticText4: TStaticText;
    TabMOS: TTabSheet;
    Panel2: TPanel;
    Edit1: TEdit;
    Button2: TButton;
    Custom: TTabSheet;
    Label8: TLabel;
    OpenDialog1: TOpenDialog;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel3: TPanel;
    Panel4: TPanel;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    FileListBox1: TFileListBox;
    FilterComboBox1: TFilterComboBox;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    CheckBox2: TCheckBox;
    Label6: TLabel;
    StaticText5: TStaticText;
    Button3: TButton;
    Button4: TButton;
    SaveDialog1: TSaveDialog;
    GIF1: TMenuItem;
    N5: TMenuItem;
    GroupBox5: TGroupBox;
    Label7: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    StaticText6: TStaticText;
    StaticText8: TStaticText;
    StaticText9: TStaticText;
    Button5: TButton;
    CheckBox3: TCheckBox;
    Label11: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Timer1Timer(Sender: TObject);
    procedure LoadImage(VMode: Integer);
    procedure FileListBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure DisplayBitmap(MWidth,MHeight,MinLeft,MinTop: LongInt; TEntry: TFrameEntry; S: TMemoryStream; Image: TImage);
    procedure SetPanel(State: Integer);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure GIF1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button5Click(Sender: TObject);
    procedure Label11Click(Sender: TObject);
    procedure N3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  mtArchive=1;
  mtFree=2;
  psNone=0;
  psBAM=1;
  psMOS=2;
  Product_Name='BAM && MOS Converter';
  Product_Version='v1.0 Alpha';
  Product_Data='03.08.2001';
  Author_Name=' ';
  Author_EMail='termius@aport2000.ru';
  Author_http='termius.narod.ru';

var
  BIFFFile: TFileBIFF;
  BAM: TBAMImage;
  ViewMode: Integer;
  Form1: TForm1;
  CustomBAM: TFileStream;
  F: TFileStream;

implementation

uses Animation, Waiting, GifSaving;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ID[1]:='B';
  ID[2]:='M';
  BMPHeader._C1:=$00000436;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0008;
  BMPHeader._H2:=$00;
  BMPHeader._H3:=$00;
  GetDir(0,DDir);
  UseAnimationImage:=False;
  ViewMode:=mtFree;
  SetPanel(psNone);
  {***    }
  DefaultOptions.Gif.Transparent:=True;
  DefaultOptions.Gif.BgColor:=clFuchsia;
  DefaultOptions.Gif.Loop:=True;
  DefaultOptions.Gif.FrameRate:=15;
  DefaultOptions.Gif.UseBgColor:=False;
  DefaultOptions.Bmp.PixelFormat:=pf8bit;
  {***  }
  if FileExists(OptionsFile) then
  begin
    F:=TFileStream.Create(DDir+'\'+OptionsFile,fmOpenRead);
    F.Read(CurrentOptions,SizeOf(CurrentOptions));
    F.Free;
  end else
  begin
    F:=TFileStream.Create(DDir+'\'+OptionsFile,fmCreate);
    F.Write(DefaultOptions,SizeOf(DefaultOptions));
    CurrentOptions:=DefaultOptions;
    F.Free;
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  LoadImage(mtArchive);
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
var
  Bmp: TMemoryStream;
  TempEntry: TFrameEntry;
begin
  if (BAM.CycleTable[UpDown1.Position-1].TotalFrames=0) then Exit;
  StaticText2.Caption:=IntToStr(ScrollBar1.Position)+'/'+IntToStr(ScrollBar1.Max);
  Bmp:=TMemoryStream.Create;
  Form1.Color:=Bam.TransColor;
  Bam.Pal[Bam.TransparentColorIndex].f:=$00;
  Bam.Pal[Bam.TransparentColorIndex].b:=((Bam.TransColor)shl 24)shr 24;
  Bam.Pal[Bam.TransparentColorIndex].g:=((Bam.TransColor)shl 16)shr 24;
  Bam.Pal[Bam.TransparentColorIndex].r:=((Bam.TransColor)shl 8)shr 24;
  if ViewMode=mtArchive then BAM.ExtractFrame(BIFFFile.F,Bmp,BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1],UpDown1.Position-1,BIFFFile.Entries[ListBox1.ItemIndex].Offset, Bam.TransColor) else BAM.ExtractFrame(CustomBAM,Bmp,BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1],UpDown1.Position-1,0, BAM.TransColor);
  if BAM.Entries[ScrollBar1.Position-1].Compressed then StaticText1.Caption:='' else StaticText1.Caption:='';
  StaticText4.Caption:=IntToStr(BAM.Entries[BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1]].Width)+'x'+IntToStr(BAM.Entries[BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1]].Height);
  StaticText5.Caption:=IntToStr(BAM.Entries[BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1]].OffsetCenterLeft)+'x'+IntToStr(BAM.Entries[BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1]].OffsetCenterTop);
  TempEntry:=BAM.Entries[BAM.Cycles[UpDown1.Position-1][ScrollBar1.Position-1]];
  if UseAnimationImage then DisplayBitmap(BAM.CycleTable[UpDown1.Position-1].MaxWidth,BAM.CycleTable[UpDown1.Position-1].MaxHeight,BAM.CycleTable[UpDown1.Position-1].MinOffsetCenterLeft,BAM.CycleTable[UpDown1.Position-1].MinOffsetCenterTop,TempEntry,BMP,Form2.Image1) else DisplayBitmap(BAM.CycleTable[UpDown1.Position-1].MaxWidth,BAM.CycleTable[UpDown1.Position-1].MaxHeight,BAM.CycleTable[UpDown1.Position-1].MinOffsetCenterLeft,BAM.CycleTable[UpDown1.Position-1].MinOffsetCenterTop,TempEntry,BMP,Image1);
  Bmp.Free;
end;

procedure TForm1.N2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  i: Word;
begin
  if OpenDialog1.Execute then
  begin
    FreeAndNil(BIFFFile);
    BIFFFile:=TFileBIFF.Create(OpenDialog1.FileName);
    ListBox1.Items.Clear;
    for i:=1 to BIFFFile.TotalFiles do
    begin
      if DetectFileType(BIFFFile,i-1)=rtBAM then ListBox1.Items.Add('BAM') else
      if DetectFileType(BIFFFile,i-1)=rtMOS then ListBox1.Items.Add('MOS') else
      ListBox1.Items.Add(' ');
    end;
    Edit1.Text:=OpenDialog1.FileName;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if ScrollBar1.Max=1 then
  begin
    MessageDlg(' :    1 .',mtCustom,[mbOk],0);
    Exit;
  end;
  ScrollBar1.Position:=1;
  UseAnimationImage:=True;
  Timer1.Enabled:=True;
  Form2.Image1.Picture.Bitmap.Width:=0;
  Form2.Image1.Picture.Bitmap.Height:=0;
  Form2.ShowModal;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  if BAM.CycleTable[UpDown1.Position-1].TotalFrames>0 then ScrollBar1.Max:=BAM.CycleTable[UpDown1.Position-1].TotalFrames else ScrollBar1.Max:=1;
  ScrollBar1.Position:=1;
  ScrollBar1.OnChange(Self);
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if ScrollBar1.Position+1<=ScrollBar1.Max then ScrollBar1.Position:=ScrollBar1.Position+1 else
  begin
    if CheckBox1.Checked then ScrollBar1.Position:=1 else
    begin
      UseAnimationImage:=False;
      Timer1.Enabled:=False;
    end;
  end;
end;

procedure TForm1.LoadImage(VMode: Integer);
var
  Temp: TFileStream;
  Bmp: TMemoryStream;
begin
  ViewMode:=VMode;
  FreeAndNil(BAM);
  if ViewMode=mtArchive then
  case DetectFileType(BIFFFile,ListBox1.ItemIndex) of
  rtNone:begin
           ScrollBox1.HorzScrollBar.Position:=0;
           ScrollBox1.VertScrollBar.Position:=0;
           Image1.Picture.Bitmap.Width:=0;
           Image1.Picture.Bitmap.Height:=0;
           Image1.Width:=0;
           Image1.Height:=0;
           SetPanel(psNone);
         end;
  rtBAM:begin
          ScrollBox1.HorzScrollBar.Position:=0;
          ScrollBox1.VertScrollBar.Position:=0;
          SetPanel(psBAM);
          BAM:=TBAMImage.Create(BIFFFile.F,BIFFFile.Entries[ListBox1.ItemIndex].Offset);
          UpDown1.Max:=BAM.TotalCycles;
          UpDown1.Position:=1;
          ScrollBar1.Position:=1;
          if BAM.CycleTable[0].TotalFrames>0 then
          begin
            ScrollBar1.Max:=BAM.CycleTable[0].TotalFrames;
            ScrollBar1.OnChange(Self);
          end else
          begin
            ScrollBar1.Max:=1;
          end;
          StaticText2.Caption:=IntToStr(ScrollBar1.Position)+'/'+IntToStr(ScrollBar1.Max);
          StaticText3.Caption:=IntToStr(BAM.TotalCycles);
        end;
  rtMOS:begin
          SetPanel(psMOS);
          Image1.Transparent:=False;
          Bmp:=TMemoryStream.Create;
          ExtractMOS(BIFFFile.F,Bmp,BIFFFile.Entries[ListBox1.ItemIndex].Offset);
          ScrollBox1.HorzScrollBar.Position:=0;
          ScrollBox1.VertScrollBar.Position:=0;
          Image1.Left:=0;
          Image1.Top:=0;
          Image1.Picture.Bitmap.LoadFromStream(Bmp);
          StaticText8.Caption:=IntToStr(MOSHeader.Width)+'x'+IntToStr(MOSHeader.Height);
          StaticText6.Caption:=IntToStr(MOSHeader.TotalColumns)+'x'+IntToStr(MOSHeader.TotalRows);
          StaticText9.Caption:=IntToStr(MOSHeader.BlockSize)+'x'+IntToStr(MOSHeader.BlockSize);
          Bmp.Free;
        end;
  end else
  begin
    FreeAndNil(BAM);
    FreeAndNil(CustomBAM);
    case DetectFileById(FileListBox1.FileName) of
    rtBAM: begin
             ScrollBox1.HorzScrollBar.Position:=0;
             ScrollBox1.VertScrollBar.Position:=0;
             SetPanel(psBAM);
             CustomBAM:=TFileStream.Create(FileListBox1.FileName,fmOpenRead);
             Bam:=TBAMImage.Create(CustomBAM,$00);
             UpDown1.Max:=BAM.TotalCycles;
             UpDown1.Position:=1;
             ScrollBar1.Position:=1;
             if BAM.CycleTable[0].TotalFrames>0 then
             begin
               ScrollBar1.Max:=BAM.CycleTable[0].TotalFrames;
               ScrollBar1.OnChange(Self);
             end else
             begin
               ScrollBar1.Max:=1;
             end;
             StaticText2.Caption:=IntToStr(ScrollBar1.Position)+'/'+IntToStr(ScrollBar1.Max);
             StaticText3.Caption:=IntToStr(BAM.TotalCycles);
           end;
     rtMOS:begin
             SetPanel(psMOS);
             Image1.Transparent:=False;
             Temp:=TFileStream.Create(FileListBox1.FileName,fmOpenRead);
             Bmp:=TMemoryStream.Create;
             ExtractMOS(Temp,Bmp,$00);
             ScrollBox1.HorzScrollBar.Position:=0;
             ScrollBox1.VertScrollBar.Position:=0;
             Image1.Left:=0;
             Image1.Top:=0;
             Image1.Picture.Bitmap.LoadFromStream(Bmp);
             StaticText8.Caption:=IntToStr(MOSHeader.Width)+'x'+IntToStr(MOSHeader.Height);
             StaticText6.Caption:=IntToStr(MOSHeader.TotalColumns)+'x'+IntToStr(MOSHeader.TotalRows);
             StaticText9.Caption:=IntToStr(MOSHeader.BlockSize)+'x'+IntToStr(MOSHeader.BlockSize);
             Bmp.Free;
             Temp.Free;
           end;
       else
       begin
         ScrollBox1.HorzScrollBar.Position:=0;
         ScrollBox1.VertScrollBar.Position:=0;
         Image1.Picture.Bitmap.Width:=0;
         Image1.Picture.Bitmap.Height:=0;
         Image1.Width:=0;
         Image1.Height:=0;
         SetPanel(psNone);
       end;
     end
  end;
end;

procedure TForm1.FileListBox1Click(Sender: TObject);
begin
  LoadImage(mtFree);
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  ScrollBar1.OnChange(Self);
end;

procedure TForm1.DisplayBitmap(MWidth,MHeight,MinLeft,MinTop: LongInt; TEntry: TFrameEntry; S: TMemoryStream; Image: TImage);
begin
  Image.Transparent:=CheckBox2.Checked;
  Image.Picture.Bitmap.TransparentColor:=BAM.TransColor;
  Image.Picture.Bitmap.LoadFromStream(S);
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  i: Integer;
  Bmp: TMemoryStream;
  TempBmp: TBitmap;
  gif: TGifImage;
  Pal: TLogPalette;
  Bg: TColor;
begin
  if (BAM.CycleTable[UpDown1.Position-1].TotalFrames=0) then Exit;
  SaveDialog1.Filter:='Gif Animated (*.gif)|*.gif';
  if not SaveDialog1.Execute then Exit;
  Form3.Show;
  TempBmp:=TBitmap.Create;
  Gif:=TGifImage.Create;
  if not CurrentOptions.Gif.Transparent then
  if CurrentOptions.Gif.UseBgColor then
  begin
    Bam.Pal[Bam.TransparentColorIndex].f:=$00;
    Bam.Pal[Bam.TransparentColorIndex].b:=((CurrentOptions.Gif.BgColor)shl 24)shr 24;
    Bam.Pal[Bam.TransparentColorIndex].g:=((CurrentOptions.Gif.BgColor)shl 16)shr 24;
    Bam.Pal[Bam.TransparentColorIndex].r:=((CurrentOptions.Gif.BgColor)shl 8)shr 24;
  end;
  for i:=1 to ScrollBar1.Max do
  begin
    Form3.Refresh;
    Bmp:=TMemoryStream.Create;
    if CurrentOptions.Gif.UseBgColor then Bg:=CurrentOptions.Gif.BgColor else Bg:=Bam.TransColor;
    if ViewMode=mtArchive then BAM.ExtractFrame(BIFFFile.F,Bmp,BAM.Cycles[UpDown1.Position-1][i-1],UpDown1.Position-1,BIFFFile.Entries[ListBox1.ItemIndex].Offset, BG) else BAM.ExtractFrame(CustomBAM,Bmp,BAM.Cycles[UpDown1.Position-1][i-1],UpDown1.Position-1,0, BG);
    Bmp.Seek(0,soFromBeginning);
    TempBmp.LoadFromStream(Bmp);
    TempBmp.PixelFormat:=pf8bit;
    Gif.AddFrame(TempBmp);
    Gif.Frames[i-1].AnimateInterval:=1000 div CurrentOptions.Gif.FrameRate;
    if CurrentOptions.Gif.Transparent then
    begin
      Gif.Frames[i-1].TransparentColor:=BAM.TransColor;
    end;
    Gif.Frames[i-1].DisposalMethod:=dmRestoreBackGround;
    TempBmp.PixelFormat:=pf24bit;
    Bmp.Free;
  end;
  Gif.Looping:=CurrentOptions.Gif.Loop;
  Gif.RepeatCount:=0;
  Gif.EncodeAllFrames;
  Gif.SaveToFile(SaveDialog1.FileName);
  Gif.Free;
  TempBmp.Free;
  Form3.Hide;
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  TB: TBitmap;
begin
  SaveDialog1.Filter:='Bitmap (*.bmp)|*.bmp';
  if not SaveDialog1.Execute then Exit;
  TB:=TBitmap.Create;
  TB.Assign(Image1.Picture.Bitmap);
  TB.PixelFormat:=CurrentOptions.Bmp.PixelFormat;
  TB.SaveToFile(SaveDialog1.FileName);
  TB.Free;
end;

procedure TForm1.SetPanel(State: Integer);
begin
  case State of
  psNone:begin
           Panel1.Width:=139;
           PageControl1.Visible:=False;
           PageControl1.ActivePage:=TabNone;
          end;
  psBAM:begin
          Panel1.Width:=329;
          PageControl1.Visible:=True;
          PageControl1.ActivePage:=TabBAM;
        end;
  psMOS:begin
          Panel1.Width:=329;
          PageControl1.Visible:=True;
          PageControl1.ActivePage:=TabMOS;
        end;
  end;
end;

procedure TForm1.GIF1Click(Sender: TObject);
begin
  Form4.ShowModal;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  {***  }
end;

procedure TForm1.Button5Click(Sender: TObject);
var
  TB: TBitmap;
begin
  SaveDialog1.Filter:='Bitmap (*.bmp)|*.bmp';
  if not SaveDialog1.Execute then Exit;
  TB:=TBitmap.Create;
  TB.Assign(Image1.Picture.Bitmap);
  if CheckBox3.Checked then TB.PixelFormat:=CurrentOptions.Bmp.PixelFormat;
  TB.SaveToFile(SaveDialog1.FileName);
  TB.Free;
end;

procedure TForm1.Label11Click(Sender: TObject);
begin
  CheckBox3.Checked:=not CheckBox3.Checked;
end;

procedure TForm1.N3Click(Sender: TObject);
begin
  ShowAbout(Product_Name,Product_Version,Product_Data,Author_Name,Author_EMail,Author_http);
end;

end.
